
proc photo'line {im x0 y0 x1 y1 args} {
    array set "" {-color black -width 1}
    array set "" $args
    set dx [expr {$x1-$x0}]
    set dy [expr {$y1-$y0}]
    set dw [expr {$(-width)/2.}]
    if {abs($dx)>abs($dy)} {
	set d [expr {double($dy)/$dx}]
	for {set x $x0} {$x<=$x1} {incr x} {
	    $im put $(-color) \
		-to $x            [expr {round($y0-$dw)}] \
		[expr {$x+1}] [expr {round($y0+$dw)}]
	    set y0 [expr {$y0 + $d}]
	}
    } else {
	set d [expr {double($dx)/$dy}]
	for {set y $y0} {$y<=$y1} {incr y} {
	    $im put $(-color) \
		-to [expr {round($x0-$dw)}] $y \
		[expr {round($x0+$dw)}] [expr {$y+1}]
	    set x0 [expr {$x0 + $d}]
	}
    }
}
namespace eval ::emboss \
    {
    namespace export emboss
    
    package require Tk
    
    proc emboss {image} \
	{
	# get the old image content
	set width [image width $image]
	set height [image height $image]
	if {$width * $height == 0} { error "bad image" }
	# create corresponding planes
	for {set y 0} {$y < $height} {incr y} \
	    {
	    set r:row {}
	    set g:row {}
	    set b:row {}
	    for {set x 0} {$x < $width} {incr x} \
		{
		foreach {r g b} [$image get $x $y] break
		foreach c {r g b} { lappend $c:row [set $c] }
	    }
	    foreach c {r g b} { lappend $c:data [set $c:row] }
	}
	# embossing
	for {set y 0} {$y < $height} {incr y} \
	    {
	    set row2 {}
	    for {set x 0} {$x < $width} {incr x} \
		{
		foreach c {r g b} \
		    {
		    set c00 [lindex [set $c:data] [expr {$y - 1}] [expr {$x - 1}]]
		    set c01 [lindex [set $c:data] [expr {$y - 1}] [expr {$x - 0}]]
		    set c02 [lindex [set $c:data] [expr {$y - 1}] [expr {$x + 1}]]
		    set c10 [lindex [set $c:data] [expr {$y + 0}] [expr {$x - 1}]]
		    set c11 [lindex [set $c:data] [expr {$y + 0}] [expr {$x - 0}]]
		    set c12 [lindex [set $c:data] [expr {$y + 0}] [expr {$x + 1}]]
		    set c20 [lindex [set $c:data] [expr {$y + 1}] [expr {$x - 1}]]
		    set c21 [lindex [set $c:data] [expr {$y + 1}] [expr {$x - 0}]]
		    set c22 [lindex [set $c:data] [expr {$y + 1}] [expr {$x + 1}]]
		    foreach v {c00 c01 c02 c10 c12 c20 c21 c22} { if {[set $v] == ""} { set $v 0.0 } }
		    set c0 [expr {128 + (-$c00 - $c01 + $c02 - $c10 - $c11 + $c12 + $c20 + $c21 + $c22)}]
		    if {$c0 < 0} { set c0 0 }
		    if {$c0 > 255} { set c0 255 }
		    set $c $c0
		}
		set c [expr {int(($r + $g + $b) / 3.0)}]
		lappend row2 [format #%02x%02x%02x $c $c $c]
	    }
	    lappend data2 $row2
	}
	# create the new image
	set image2 [image create photo]
	# fill the new image
	$image2 put $data2
	# return the new image
	return $image2
    }
}